Kea: isc::dhcp::DHCPQueueControlParser Class Reference

| Kea 3.2.0-git

isc::dhcp::DHCPQueueControlParser Class Reference

Parser for the configuration of DHCP packet queue controls. More...

`#include <dhcp_queue_control_parser.h>`

Inheritance diagram for isc::dhcp::DHCPQueueControlParser:
[legend]

## Public Member Functions
| DHCPQueueControlParser ()
| Constructor.
data::ElementPtr | parse (const isc::data::ConstElementPtr &control_elem, bool multi_threading_enabled)
| Parses content of the "dhcp-queue-control".
Public Member Functions inherited from isc::data::SimpleParser
uint16_t | getUint16 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint16_t.
uint32_t | getUint32 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint32_t.
uint8_t | getUint8 (ConstElementPtr scope, const std::string &name)
| Get an uint8_t value.
const isc::util::Triplet< uint32_t > | parseIntTriplet (const data::ConstElementPtr &scope, const std::string &name)
| Parses an integer triplet.

## Additional Inherited Members
Static Public Member Functions inherited from isc::data::SimpleParser
static void | checkKeywords (const SimpleKeywords &keywords, isc::data::ConstElementPtr scope)
| Checks acceptable keywords with their expected type.
static void | checkRequired (const SimpleRequiredKeywords &required, isc::data::ConstElementPtr scope)
| Checks that all required keywords are present.
static size_t | deriveParams (isc::data::ConstElementPtr parent, isc::data::ElementPtr child, const ParamsList &params)
| Derives (inherits) parameters from parent scope to a child.
static isc::asiolink::IOAddress | getAddress (const ConstElementPtr &scope, const std::string &name)
| Returns a IOAddress parameter from a scope.
static bool | getBoolean (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a boolean parameter from a scope.
static double | getDouble (const ConstElementPtr &scope, const std::string &name)
| Returns a floating point parameter from a scope.
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer parameter from a scope.
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name, int64_t min, int64_t max)
| Returns an integer parameter from a scope and checks its range.
static const data::Element::Position & | getPosition (const std::string &name, const data::ConstElementPtr parent)
| Utility method that returns position of an element.
static std::string | getString (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a string parameter from a scope.
template<typename T>
static void | rangeCheckedInteger (isc::data::ConstElementPtr scope, const std::string &name, T &output_value)
| Fetches a range-checked integer parameter from a scope.
static size_t | setDefaults (isc::data::ElementPtr scope, const SimpleDefaults &default_values)
| Sets the default values.
static size_t | setListDefaults (isc::data::ConstElementPtr list, const SimpleDefaults &default_values)
| Sets the default values for all entries in a list.
Protected Member Functions inherited from isc::data::SimpleParser
template<typename target_type, target_type convert>
target_type | getAndConvert (isc::data::ConstElementPtr scope, const std::string &name, const std::string &type_name)
| Returns a converted value from a scope.
template<typename int_type>
int_type | getIntType (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer value with range checking from a scope.

## Detailed Description

Parser for the configuration of DHCP packet queue controls.

This parser parses the "dhcp-queue-control" parameter which holds the the configurable parameters that tailor DHCP packet queue behavior. In order to provide wide latitude to packet queue implementators, 'dhcp-queue-control' is mostly treated as a map of arbitrary values. There is only mandatory value, 'enable-queue', which enables/disables DHCP packet queueing. If this value is true, then the content must also include a value for 'queue-type'. Beyond these values, the map may contain any combination of valid JSON elements.

Unlike most other parsers, this parser primarily serves to validate the aforementioned rules, and rather than instantiate an object as a result, it simply returns a copy original map of elements.

This parser is used in both DHCPv4 and DHCPv6. Derived parsers are not needed.

Definition at line 34 of file dhcp_queue_control_parser.h.

## Constructor & Destructor Documentation

## ◆ DHCPQueueControlParser()

isc::dhcp::DHCPQueueControlParser::DHCPQueueControlParser | ( |  | ) |
| inline

Constructor.

Definition at line 38 of file dhcp_queue_control_parser.h.

## Member Function Documentation

## ◆ parse()

ElementPtr isc::dhcp::DHCPQueueControlParser::parse | ( | const isc::data::ConstElementPtr & | control_elem,
|  | bool | multi_threading_enabled )

Parses content of the "dhcp-queue-control".

Parameters

  control_elem | MapElement containing the queue control values to parse.
  multi_threading_enabled | The flag which indicates if MT is enabled.

Returns
  A copy of the of the input MapElement.

Exceptions

  DhcpConfigError | if any of the values are invalid.

Definition at line 23 of file dhcp_queue_control_parser.cc.

References isc::data::copy(), isc::data::Element::create(), isc::dhcp::dhcpsrv_logger, isc::dhcp::DHCPSRV_MT_DISABLED_QUEUE_CONTROL, isc::data::SimpleParser::getBoolean(), isc_throw, LOG_WARN, isc::data::Element::map, and isc::data::Element::string.

Referenced by isc::dhcp::processDhcp4Config(), and isc::dhcp::processDhcp6Config().

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- dhcp_queue_control_parser.h
- dhcp_queue_control_parser.cc